#########################################################################################################
#     =-----+                                       $                                             ##   #
#  #############$                      ###         ###-                ###                         ##   #
####        o,#                       ##                             ###                         ##   #
###                       o+++       $## .++o   .إ                ### +++        0++++0      ##   #
###-                   0#########    ##########   ##               ##########+    .##########    ##   #
#-###                 ###    ###      ##         o##                 ###         ####    ###    ###  #
# ##########+        #        ###    +##         o##                 ###         ##        =    ##   #
#        #######     ###0#########    o##         o##                 ###        ###              ##   #
#             $##    ##############    o##         o##                 ###        ###              ##   #
#              ##    ##o               o##         o##                 ###        ###              ##   #
##            ##    ###$             $##         o##                 ###        ###            ##   #
#####-     +####      #####     ###    -###    #   o##       ###      ###   #    #####    ###    ##   #
# o+########0          0######0#      o######   o##       ###       #####      $#####o#    ##   #
#                                      -== BlackCat @ Efnet ==-                                         #
#########################################################################################################
# Version 1.2 (first rls)                                                                               #
#                                                                                                       #
# If you want to join our team -> http://seti23.org                                                     #
#                                                                                                       #
# What this is:                                                                                         #
# -> This TCL will let you get you Seti@home stats my msging or typing your email in the chan           #
#     It has Full stats and Normal stats, it will also get your team stats                              #
#     You can set a defult team and you can also get other team stats                                   #
#                                                                                                       #
# -> This is the first Public Rls so I add a help command                                               #
#     Type !help in your chan to see the list of commands                                               #
#                                                                                                       #
# Pls enjoy ;)                                                                                          #
#########################################################################################################
#
#
# This tlc has been tested on Eggdrop v1.6.13 and still is running on Efnet
###############################################
# About # BlackCat's Tlc -=-Seti.tcl-=-       #
# Team # Made for seti team                 #
# BlackCat@mchsi.com                          #
# /msg #manofpower -=- to leave a msg on EFNET#
###############################################
#
#
#
#
###############
# CONFIG PART #
###############
#
###########################################
# Set what chan you want it to display in #
# example -=- set chann "#seti23"         #
###########################################

set chann "#setiathome"

#########################################
# To set your defalt team enter it here #
# example -=- set teamster ""         #
#########################################

set  teamster ""

####################
# Basic commands
# Once loaded type
#
# >>> !help <<< in the chan for command list
#
####################################################################
# Don't edit below this line, it will cause the script not to work #
#                                                                  #
####################################################################
bind pub - !info getter
bind msg - !info getter2
proc getter {nick host hand chan text} {
global chann
set email [lindex $text 0]
egghttp:geturl http://setiathome.ssl.berkeley.edu/fcgi-bin/fcgi?cmd=user_xml&email=$email callback -query
putserv "PRIVMSG $chann : Getting normal info for $nick." }
proc getter2 {nick host hand text} {
global chann
set email [lindex $text 0]
egghttp:geturl http://setiathome.ssl.berkeley.edu/fcgi-bin/fcgi?cmd=user_xml&email=$email callback -query
putserv "PRIVMSG $chann : Getting normal info for $nick" }
bind pub - !full getter3
bind msg - !full getter4
proc getter3 {nick host hand chan text} {
global chann
set email [lindex $text 0]
egghttp:geturl http://setiathome.ssl.berkeley.edu/fcgi-bin/fcgi?cmd=user_xml&email=$email callback_full -query
putserv "PRIVMSG $chann : That-a-way $nick, full info." }
proc getter4 {nick host hand text} {
global chann
set email [lindex $text 0]
egghttp:geturl http://setiathome.ssl.berkeley.edu/fcgi-bin/fcgi?cmd=user_xml&email=$email callback_full -query
putserv "PRIVMSG $chann : That-a-way $nick, full info." }
proc callback_full {sock} {
global chann
set data [egghttp:data $sock]
egghttp:cleanup $sock
regsub -all {<a [^>]+>} $data {} text2
regsub -all {</a>} $text2 {} text3
regsub -all {<! [^>]+>} $text3 {} text
set name [string range $text [expr [string first {<name>} $text] +6] [expr [string first {</name>} [string range $text [string first $text {</name>}] end]]-1]]
set amount [string range $text [expr [string first {<numresults>} $text] +12] [expr [string first {</numresults>} [string range $text [string first $text {</numresults>}] end]]-1]]
set avgtime [string range $text [expr [string first {<avecpu>} $text] +8] [expr [string first {</avecpu>} [string range $text [string first $text {</avecpu>}] end]]-1]]
set totaltime [string range $text [expr [string first {<cputime>} $text] +9] [expr [string first {</cputime>} [string range $text [string first $text {</cputime>}] end]]-1]]
set group [string range $text [expr [string first {<group>} $text] +7] [expr [string first {</group>} [string range $text [string first $text {</group>}] end]]-1]]
set resultsperday [string range $text [expr [string first {<resultsperday>} $text] +15] [expr [string first {</resultsperday>} [string range $text [string first $text {</resultsperday>}] end]]-1]]
set lastresulttime [string range $text [expr [string first {<lastresulttime>} $text] +16] [expr [string first {</lastresulttime>} [string range $text [string first $text {</lastresulttime>}] end]]-1]]
set regdate [string range $text [expr [string first {<regdate>} $text] +9] [expr [string first {</regdate>} [string range $text [string first $text {</regdate>}] end]]-1]]
set usertime [string range $text [expr [string first {<usertime>} $text] +10] [expr [string first {</usertime>} [string range $text [string first $text {</usertime>}] end]]-1]]
set top_rank [string range $text [expr [string first {<top_rankpct>} $text] +13] [expr [string first {</top_rankpct>} [string range $text [string first $text {</top_rankpct>}] end]]-1]]
set eq1 [expr $top_rank - 100]
set eq [expr $eq1 * -1]
putserv "PRIVMSG $chann :Full Stats for \002$name\002: WUs: \002$amount\002. Avg.Time/WU: \002$avgtime\002. Avg. Results/Perday: \002$resultsperday\002. Last Result: \002$lastresulttime\002. TotalTime/WU:\002$totaltime\002. Completed more work units then: \002$eq %\002 of people. Total seti member time: \002$usertime\002. Group: \002$group\002." }
bind pub - !help helper23
proc helper23 {nick host hand chan text} {
putserv "NOTICE $nick :Your reg. info with Privit Msg -> /msg <botnick> !info <your_email>"
putserv "NOTICE $nick :Your reg. info with Public -> !info <your_email>"
putserv "NOTICE $nick :Your full info with Privt Msg -> /msg <botnick> !full <your_email>"
putserv "NOTICE $nick :Your full info with Public -> !full <your_email>"
putserv "NOTICE $nick :Gettting team stats when you have a default team -> !team"
putserv "NOTICE $nick :Gettting team info on any team -> !teamsearch <the other team>"
putserv "NOTICE $nick :Team seti23 @ efnet -=- Team with the toolz" }
proc callback {sock} {
global chann
set data [egghttp:data $sock]
egghttp:cleanup $sock
regsub -all {<a [^>]+>} $data {} text2
regsub -all {</a>} $text2 {} text3
regsub -all {<! [^>]+>} $text3 {} text
set name [string range $text [expr [string first {<name>} $text] +6] [expr [string first {</name>} [string range $text [string first $text {</name>}] end]]-1]]
set amount [string range $text [expr [string first {<numresults>} $text] +12] [expr [string first {</numresults>} [string range $text [string first $text {</numresults>}] end]]-1]]
set avgtime [string range $text [expr [string first {<avecpu>} $text] +8] [expr [string first {</avecpu>} [string range $text [string first $text {</avecpu>}] end]]-1]]
set totaltime [string range $text [expr [string first {<cputime>} $text] +9] [expr [string first {</cputime>} [string range $text [string first $text {</cputime>}] end]]-1]]
set group [string range $text [expr [string first {<group>} $text] +7] [expr [string first {</group>} [string range $text [string first $text {</group>}] end]]-1]]
putserv "PRIVMSG $chann :Stats for \002$name\002: WUs: \002$amount\002. Avg.Time/WU: \002$avgtime\002. TotalTime/WU:\002$totaltime\002. Team: \002$group\002." }
putlog "Smoke one up for the cat.... BlackCat Made ::: BlackCat@efnet"
bind pub - !team teamgetter
proc teamgetter {nick host hand chan text} {
global chann teamster
egghttp:geturl http://setiathome.ssl.berkeley.edu/fcgi-bin/fcgi?cmd=team_lookup_xml&name=$teamster callmeback -query }
proc callmeback {sock} {
global chann
set data [egghttp:data $sock]
egghttp:cleanup $sock
regsub -all {<topmembers [^>]+>} $data {} text2
regsub -all {</a>} $text2 {} text3
regsub -all {<! [^>]+>} $text3 {} text
set team [string range $text [expr [string first {<name>} $text] +6] [expr [string first {</name>} [string range $text [string first $text {</name>}] end]]-1]]
set m_amount [string range $text [expr [string first {<nummembers>} $text] +12] [expr [string first {</nummembers>} [string range $text [string first $text {</nummembers>}] end]]-1]]
set amount [string range $text [expr [string first {<numresults>} $text] +12] [expr [string first {</numresults>} [string range $text [string first $text {</numresults>}] end]]-1]]
set total [string range $text [expr [string first {<totalcpu>} $text] +10] [expr [string first {</totalcpu>} [string range $text [string first $text {</totalcpu>}] end]]-1]]
putserv "PRIVMSG $chann :Group Stats for \002$team\002: WUs: \002$amount\002. Members: \002$m_amount\002. Time/WU: \002$total\002." }
bind pub - !teamsearch teamgetter8
proc teamgetter8 {nick host hand chan text} {
global chann 
set team_lop_op [lrange $text 0 end]
regsub -all { } $team_lop_op {%20} team_lop
egghttp:geturl http://setiathome.ssl.berkeley.edu/fcgi-bin/fcgi?cmd=team_lookup_xml&name=$team_lop callmeback_lop -query }
proc callmeback_lop {sock} {
global chann
set data [egghttp:data $sock]
egghttp:cleanup $sock
regsub -all {<topmembers [^>]+>} $data {} text2
regsub -all {</a>} $text2 {} text3
regsub -all {<! [^>]+>} $text3 {} text
set team [string range $text [expr [string first {<name>} $text] +6] [expr [string first {</name>} [string range $text [string first $text {</name>}] end]]-1]]
set m_amount [string range $text [expr [string first {<nummembers>} $text] +12] [expr [string first {</nummembers>} [string range $text [string first $text {</nummembers>}] end]]-1]]
set amount [string range $text [expr [string first {<numresults>} $text] +12] [expr [string first {</numresults>} [string range $text [string first $text {</numresults>}] end]]-1]]
set total [string range $text [expr [string first {<totalcpu>} $text] +10] [expr [string first {</totalcpu>} [string range $text [string first $text {</totalcpu>}] end]]-1]]
putserv "PRIVMSG $chann :Group Stats for \002$team\002: WUs: \002$amount\002. Members: \002$m_amount\002. Time/WU: \002$total\002." 
}



